﻿Type=Service
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

#Region  Service Attributes 
   #StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Dim TimerService As Timer
	Dim Counter As Int
	Counter = 0
	Dim N As Notification
	Dim p As PhoneWakeState
	Dim timer1 As Timer

	Type SensorData (Name As String, ThreeValues As Boolean)

	Dim AccelX As Float
	Dim AccelY As Float
	Dim AccelZ As Float
	Dim AccelXprev As Float
	Dim AccelYprev As Float
	Dim AccelZprev As Float

	Dim PE As PhoneEvents
	Dim BatteryLevel As Int
	Dim BatteryPlugged As Boolean	

	Dim sd As SensorData
	Dim ps As PhoneSensors

End Sub
Sub Service_Create
	'TimerService.Initialize("TimerService",1000)
	'TimerService.Enabled=True
	
	n.Initialize
	n.Icon = "icon"
	n.Sound = False
	n.Vibrate = False
	n.Light = False
	n.OnGoingEvent=True

	AddSensor(ps.TYPE_ACCELEROMETER, "ACCELEROMETER", True)
	PE.Initialize("PE1") 
	
	LogD("Create Service")
	n.SetInfo("Timer Start", Counter, Main) 
	'Change Main (above) to "" if this code is in the main module.
	n.Notify(1) 
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Counter = Counter+1
	n.SetInfo("Timer Start", Counter, Main) 
	'Change Main (above) to "" if this code is in the main module.
	n.Notify(1) 
	
	LogD("Start Service")
	StartServiceAt("",DateTime.Now+DateTime.TicksPerSecond*10,True)
	
'  	Log("releasing KeepAlive")
'   	p.ReleaseKeepAlive
'   	Log("turning screen on")
'   	p.KeepAlive(True)
'   	Log("using partialLock")
'   	p.PartialLock
	
	timer1.Initialize("timer1", 5000)
	timer1.Enabled = True
	
End Sub

Sub Service_Destroy
	LogD("Destroy Service")
'	p.ReleaseKeepAlive

	n.Cancel(1)
End Sub
Sub timer1_tick
	LogD("timer1 tick")
	p.ReleaseKeepAlive
	timer1.Enabled = False
	FileLog("timer1: " & Counter & ", Bat:" & BatteryLevel & "%, Pluged:" & BatteryPlugged & ", X:" & NumberFormat(AccelX, 2, 1) & ", Y:" & NumberFormat(AccelY, 2, 1) & ", Z:" & NumberFormat(AccelZ, 2, 1))
End Sub
Public Sub LogD(s As String)
   Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " : " & s)
End Sub
Sub AddSensor(SensorType As Int, Name As String, ThreeValues As Boolean) As SensorData
	sd.Initialize
	sd.Name = Name
	sd.ThreeValues = ThreeValues
	ps.Initialize(SensorType)
	ps.StartListening("Sensor")
	Log(Name & " MaxValue = " & ps.MaxValue)
End Sub
Sub Sensor_SensorChanged (Values() As Float)

	'Get the PhoneSensors object that raised this event.
	ps = Sender

	AccelXprev = AccelX
	AccelYprev = AccelY
	AccelZprev = AccelZ
	AccelX = Values(0)
	AccelY = Values(1)
	AccelZ = Values(2)
		
	If Abs(AccelXprev - AccelX) > 2 Then
		p.KeepAlive(True)
	End If
	If Abs(AccelYprev - AccelY) > 2 Then
		p.KeepAlive(True)
	End If
	If Abs(AccelZprev - AccelZ) > 2 Then
		p.KeepAlive(True)
	End If
	
End Sub
Sub FileLog(s As String)
	Dim Writer As TextWriter
	Writer.Initialize (File.OpenOutput (File.DirRootExternal, "Service.txt", True))
	Writer.Write(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " : " & s & CRLF)
	Writer.Close
End Sub
Sub PE1_BatteryChanged (Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)       
	BatteryLevel = Level
	BatteryPlugged = Plugged
	LogD("BatteryChanged: Level = " & BatteryLevel & ", Scale = " & Scale & ", Plugged = " & BatteryPlugged)
End Sub
Sub PE1_ScreenOff (Intent As Intent)
    LogD("Screen is OFF")
'	p.PartialLock
	ps.StartListening("Sensor")
'	AddSensor(ps.TYPE_ACCELEROMETER, "ACCELEROMETER", True)
End Sub

Sub PE1_ScreenOn (Intent As Intent)
    LogD("Screen is ON")
End Sub